import { SemanticMark } from "./semantic-mark";

import { field as getFieldAccessor } from "@visactor/vgrammar-util";

import { PlotMakType } from "./enums";

import { GrammarMarkType } from "@visactor/vgrammar-core";

export class PolygonSemanticMark extends SemanticMark {
    constructor(id) {
        super(PlotMakType.polygon, id);
    }
    setMarkType() {
        return GrammarMarkType.polygon;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const markEncoder = this.convertSimpleMarkEncode(encode), scaleXId = this.getScaleId("x"), scaleYId = this.getScaleId("y"), res = {};
        if ((null === (_b = null === (_a = markEncoder.x) || void 0 === _a ? void 0 : _a.field) || void 0 === _b ? void 0 : _b.length) && (null === (_d = null === (_c = markEncoder.y) || void 0 === _c ? void 0 : _c.field) || void 0 === _d ? void 0 : _d.length)) {
            const xAccessors = markEncoder.x.field.map((f => getFieldAccessor(f))), yAccessors = markEncoder.y.field.map((f => getFieldAccessor(f)));
            res.points = (datum, el, params) => {
                const scaleX = params[scaleXId], scaleY = params[scaleYId], minLen = Math.min(xAccessors.length, yAccessors.length), points = [];
                for (let i = 0; i < minLen; i++) points.push({
                    x: scaleX.scale(xAccessors[i](datum)),
                    y: scaleY.scale(yAccessors[i](datum))
                });
                return points;
            };
        }
        return markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_e = markEncoder.color) && void 0 !== _e ? _e : markEncoder.group : res.fill = null !== (_g = null === (_f = this.spec.style) || void 0 === _f ? void 0 : _f.fill) && void 0 !== _g ? _g : null === (_h = this.getPalette()) || void 0 === _h ? void 0 : _h[0], 
        res;
    }
}

PolygonSemanticMark.type = PlotMakType.polygon;
//# sourceMappingURL=polygon.js.map