import { SemanticMark } from "./semantic-mark";

import { GrammarMarkType } from "@visactor/vgrammar-core";

import { PlotMakType } from "./enums";

export class TextSemanticMark extends SemanticMark {
    constructor(id) {
        super(PlotMakType.text, id);
    }
    setMarkType() {
        return GrammarMarkType.text;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = markEncoder;
        return res.text && (res.text = {
            field: res.text.field
        }), markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.fill = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

TextSemanticMark.type = PlotMakType.text;
//# sourceMappingURL=text.js.map