import type { TreemapEncodeChannels, WithDefaultEncode, PlotTreemapEncodeSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, IElement, LabelSpec, InteractionSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class TreemapSemanticMark extends SemanticMark<PlotTreemapEncodeSpec, TreemapEncodeChannels> {
    static readonly type = PlotMakType.treemap;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultDataTransform(): TransformSpec[];
    parseScaleByEncode(channel: TreemapEncodeChannels, option: ValueOf<WithDefaultEncode<PlotTreemapEncodeSpec, TreemapEncodeChannels>, TreemapEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotTreemapEncodeSpec, TreemapEncodeChannels>): GenerateBaseEncodeSpec<PlotTreemapEncodeSpec>;
    setMainMarkSpec(): {
        key: string;
    };
    protected parseLabelSpec(): {
        marks: LabelSpec[];
        interactions: InteractionSpec[];
    };
    setMultiMarksSpec(): {
        id: string;
        type: string;
        from: {
            data: string;
        };
        layout: {
            position: string;
            skipBeforeLayouted: boolean;
        };
        key: string;
        dependency: string[];
        animation: import("@visactor/vgrammar-core").MarkAnimationSpec;
        encode: {
            enter: {
                textAlign: string;
                textBaseline: string;
            } & Partial<import("@visactor/vrender-core").ITextGraphicAttribute>;
            update: (datum: any, el: IElement, params: any) => {
                x: number;
                y: number;
                text: any;
            };
        };
    }[];
}
